
package de.ivu.elect.presentation.ergebnis.menu;

import javax.inject.Inject;

import de.ivu.elect.business.ergebnis.boundary.ErgebnisSessionSelect;
import de.ivu.elect.business.ergebnis.entity.Ergebnis;
import de.ivu.elect.business.security.UseCasePermission;
import de.ivu.elect.business.stimmeingabe.control.ListenwahlStimmeingabeKonfiguration;
import de.ivu.elect.business.wahl.boundary.WahlSessionSelect;
import de.ivu.elect.business.wahl.entity.Wahl;
import de.ivu.elect.business.wahl.entity.WahlParameterExtendedLoader;
import de.ivu.elect.presentation.kandidatur.ListenkandidaturNachErfassungsgebietStimmenSearchView;
import de.ivu.elect.presentation.menu.AbstractMenuItemEntry;
import de.ivu.elect.presentation.security.AbstractGebietSecurity;

public class ListenkandidaturNachErfassungsgebietStimmenAnzeigenMenuItemEntry extends AbstractMenuItemEntry {

  private static final long serialVersionUID = 1L;

  @Inject
  private transient WahlSessionSelect wahlSessionSelect;

  @Inject
  private transient ErgebnisSessionSelect ergebnisSessionSelect;

  @Inject
  private transient ErgebnisMenuDisabled ergebnisMenuDisabled;

  @Inject
  private transient WahlParameterExtendedLoader wahlParameterExtendedLoader;

  @Inject
  private transient ListenwahlStimmeingabeKonfiguration listenwahlStimmeingabeKonfiguration;

  public ListenkandidaturNachErfassungsgebietStimmenAnzeigenMenuItemEntry() {
    super();
  }

  @Override
  protected AbstractGebietSecurity getGebietSecurity() {
    return getEinsehenGebietSecurity();
  }

  @Override
  public boolean isRendered() {
    return hasUseCasePermission(UseCasePermission.ERGEBNIS_GRUPPEN_NACH_GEBIETEN_ANZEIGEN) && isWahlMitListenkandidaturStimmenErfassbar();
  }

  private boolean isWahlMitListenkandidaturStimmenErfassbar() { // ELECT-9223
    if (isWahlSelected() && getSelectedWahl().isWahlMitListenkandidatenStimmen() && isErgebnisSelected()) {
      Ergebnis ergebnis = getSelectedErgebnis();

      return listenwahlStimmeingabeKonfiguration.isErgebnismeldungVorlaeufigKomplett(wahlParameterExtendedLoader, ergebnis.getWahl(), ergebnis.getErgebnisart())
          || listenwahlStimmeingabeKonfiguration.isErgebnismeldungEndgueltigKomplett(wahlParameterExtendedLoader, ergebnis.getWahl(), ergebnis.getErgebnisart());
    }

    return false;
  }

  @Override
  public boolean isDisabledInternal() {
    // ELECT-3199: Die Ansicht soll auch bei vorläufiger Erfassung zugänglich sein.
    return ergebnisMenuDisabled.isDisabled(this);
  }

  @Override
  public String getLabelKey() {
    return "listenkandidatur.nach.gebiet.stimmen.anzeigen.tabellarisch.menu.item.label";
  }

  @Override
  public String getTargetViewId() {
    return ListenkandidaturNachErfassungsgebietStimmenSearchView.VIEW_ID;
  }

  @Override
  public String getIcon() {
    return getIcons().getIconCalculate();
  }

  protected boolean isWahlSelected() {
    return wahlSessionSelect.isSelected();
  }

  protected Wahl getSelectedWahl() {
    return wahlSessionSelect.getEntity();
  }

  protected boolean isErgebnisSelected() {
    return ergebnisSessionSelect.isSelected();
  }

  protected Ergebnis getSelectedErgebnis() {
    return ergebnisSessionSelect.getEntity();
  }
}
